<?php

namespace Litecms\Ourteam\Http\Controllers;

use App\Http\Controllers\PublicController as BaseController;
use Litecms\Ourteam\Interfaces\OurteamRepositoryInterface;

class OurteamPublicController extends BaseController
{
    // use OurteamWorkflow;

    /**
     * Constructor.
     *
     * @param type \Litecms\Ourteam\Interfaces\OurteamRepositoryInterface $ourteam
     *
     * @return type
     */
    public function __construct(OurteamRepositoryInterface $ourteam)
    {
        $this->repository = $ourteam;
        parent::__construct();
    }

    /**
     * Show ourteam's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $ourteams = $this->repository
        ->pushCriteria(app('Litepie\Repository\Criteria\RequestCriteria'))
        ->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();


        return $this->response->title(trans('$ourteam::$ourteam.names'))
            ->view('$ourteam::public.ourteam.index')
            ->data(compact('$ourteams'))
            ->output();
    }

    /**
     * Show ourteam's list based on a type.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function list($type = null)
    {
        $ourteams = $this->repository
        ->pushCriteria(app('Litepie\Repository\Criteria\RequestCriteria'))
        ->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();


        return $this->response->title(trans('$ourteam::$ourteam.names'))
            ->view('$ourteam::public.ourteam.index')
            ->data(compact('$ourteams'))
            ->output();
    }

    /**
     * Show ourteam.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $ourteam = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->response->title($$ourteam->name . trans('$ourteam::$ourteam.name'))
            ->view('$ourteam::public.ourteam.show')
            ->data(compact('$ourteam'))
            ->output();
    }

}
